##_______________________________________________________________________________________________
##
##                                      CONV-TTL-RS485 PTS
##
##                                         CERN,BE/CO-HT
##_______________________________________________________________________________________________
##
##-----------------------------------------------------------------------------------------------
##
##                                   CONV-TTL-RS485 flash test
##
##-----------------------------------------------------------------------------------------------
##
## Description  FILL ME!!! FILL ME!!! FILL ME!!! FILL ME!!! FILL ME!!! FILL ME!!! FILL ME!!! 
##                                                                                              
##
## Authors      Julian Lewis (Julian.Lewis@cern.ch)
##              Theodor-Adrian Stana (t.stana@cern.ch)
## Website      http://www.ohwr.org/projects/pts
## Date         05/11/2014
##-----------------------------------------------------------------------------------------------
##
##------------------------------------------------------------------------------------------------
##                               GNU LESSER GENERAL PUBLIC LICENSE
##                              ------------------------------------
## This source file is free software; you can redistribute it and/or modify it under the terms of
## the GNU Lesser General Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## This source is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
## without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
## See the GNU Lesser General Public License for more details.
## You should have received a copy of the GNU Lesser General Public License along with this
## source; if not, download it from http://www.gnu.org/licenses/lgpl-2.1.html
##-------------------------------------------------------------------------------------------------

##-------------------------------------------------------------------------------------------------
##                                            Import
##-------------------------------------------------------------------------------------------------

# Import system modules
import sys
sys.path.append("lib/")
import time
import os, errno, re, sys, struct
import os.path
import traceback
import glob
import binascii

# Import common modules
from ctypes import *
from ptsexcept import *
from vv_pts import *
from ptsdefine import *


##-------------------------------------------------------------------------------------------------
##                                             main                                              --
##-------------------------------------------------------------------------------------------------

def main(bus,tname,inf,log):

    """
    tests : EEPROM chip IC62
    uses  : release.bit and flash_test.py
    """

    pel = PTS_ERROR_LOGGER(inf,log)

    try:

        bid = bus.vv_read(0x00)
        bid = binascii.unhexlify("%s" % "{0:x}".format(bid))
        if (bid == "T485"):
            msg = "Board ID '%s' correct\n" % bid
            inf.write(msg)
        else:
            msg = "ERROR: Board ID incorrect, check IC62"
            pel.set(msg)

        return pel.get()

    except BusException, e:
        raise PtsError("SKT Exception: %s" % (e))

    except BusWarning, e:
        raise PtsError("SKT Warning: %s" % (e))

if __name__ == '__main__':
    bus = SKT(ELMASLOT)
    os.chdir("log")
    logname = glob.glob('*.log')
    infname = glob.glob('*.inf')
    log = open(logname[0],'a')
    inf = open(infname[0],'a')

    log.write("Run:1 Begin: test08\n")
    inf.write("Run:1 Begin: test08\n")
    try:
	ret = main(bus, 'test08', inf, log)
	if (ret == 0):
	    log.write("PASS: test08\n")
	else:
	    log.write("FAIL: test08->flashtest.py\n")
    except Exception as e:
	msg = "FAIL: test08->flashtest.py (%s)" % e
	log.write(msg + '\n')
	inf.write(msg + '\n')
	print msg

    log.write("Run:1 End: test08\n")
    inf.write("Run:1 End: test08\n")

